//состояние кнопок по умолчанию
bool okSwitchState, longOkSwitchState, ok2xSwitchState;
bool upSwitchState, downSwitchState, cancelSwitchState;

#ifdef ENC
void timerIsr() { encoder->service(); }
#else
bool button_state = false;
bool button_long_state = false;
#endif

long ms_button = 0;
byte delayKey = 50;

void read_keys() // ------- Reading KEY
{
  okSwitchState     = 0;
  longOkSwitchState = 0;
  ok2xSwitchState   = 0;
  upSwitchState     = 0;
  downSwitchState   = 0;
  cancelSwitchState = 0;
  
#ifdef ENC //Encoder

  valEnc += encoder->getValue();
  if (valEnc != lastEnc) {
    int iEnc = valEnc - lastEnc;
    lastEnc = valEnc;
    if (iEnc > 0) {
      upSwitchState = true;
      return;
    }
    else {
      downSwitchState = true;
      return;
    }
  }

  ClickEncoder::Button b = encoder->getButton();
  if (b != ClickEncoder::Open) {
    switch (b) {
      case ClickEncoder::Clicked: {
        okSwitchState = true;
        return;        
      }
      case ClickEncoder::DoubleClicked: {
        ok2xSwitchState = true;
        return;
      }
      case ClickEncoder::Held: {
        longOkSwitchState = true;
        return;
      }
      break;
    }
  }
  
#else //Keyboard

  byte OkSwitch = digitalRead(OkSwitchPin);
  if (OkSwitch == HIGH) OkSwitch = LOW; else OkSwitch = HIGH;
  //фиксируем момент нажатия кнопки "ОК"
  if (OkSwitch == HIGH && !button_state && (millis() - ms_button) > delayKey) {
     button_state = true;
     button_long_state = false;
     ms_button = millis();
  }
  //удержание "ОК" 1+ секунд  
  if (OkSwitch == HIGH && !button_long_state && (millis() - ms_button) > 1500) {
    button_state = false;
    button_long_state = true;
    longOkSwitchState = true;
    ms_button =  millis();
    return;
  }
  //чтобы после long_state "ОК" не считалась нажатой
  if (OkSwitch == LOW && button_long_state) {
    button_long_state = false;
    ms_button = millis();
    return;
  }
  //КОРОТКОЕ - сработает после отпускания "ОК"
  if (OkSwitch == LOW && button_state && (millis() - ms_button) > delayKey) {            
    button_state = false;
    okSwitchState = true;
    ms_button = millis();
    return;
  }

  byte UpSwitch = digitalRead(UpSwitchPin);
  if (UpSwitch == HIGH) UpSwitch = LOW; else UpSwitch = HIGH;
  if (UpSwitch == HIGH && (millis() - ms_button) > delayKey) {            
    upSwitchState = true;
    ms_button = millis();
    return;
  } 
  
  byte DownSwitch = digitalRead(DownSwitchPin);
  if (DownSwitch == HIGH) DownSwitch = LOW; else DownSwitch = HIGH;
  if (DownSwitch == HIGH && (millis() - ms_button) > delayKey) {             
    downSwitchState = true;
    ms_button = millis();
    return;
  }  

#endif

  byte CancelSwitch = digitalRead(CancelSwitchPin);
  if (CancelSwitch == HIGH) CancelSwitch = LOW; else CancelSwitch = HIGH;
  if (CancelSwitch == HIGH && (millis() - ms_button) > delayKey / 2) {
    cancelSwitchState = true;
    ms_button = millis();
    return;
  } 

  return;
  
} //end void read_keys

